|
|
218e99 |
From fdd55f6fb66d89ff7d241395419de8615e2063a4 Mon Sep 17 00:00:00 2001
|
|
|
218e99 |
From: Max Reitz <mreitz@redhat.com>
|
|
|
218e99 |
Date: Thu, 7 Nov 2013 12:16:30 +0100
|
|
|
218e99 |
Subject: [PATCH 13/87] qemu-iotests: Overlapping cluster allocations
|
|
|
218e99 |
|
|
|
218e99 |
RH-Author: Max Reitz <mreitz@redhat.com>
|
|
|
218e99 |
Message-id: <1383604354-12743-16-git-send-email-mreitz@redhat.com>
|
|
|
218e99 |
Patchwork-id: 55315
|
|
|
218e99 |
O-Subject: [RHEL-7.0 qemu-kvm PATCH 15/43] qemu-iotests: Overlapping cluster allocations
|
|
|
218e99 |
Bugzilla: 1004347
|
|
|
218e99 |
RH-Acked-by: Kevin Wolf <kwolf@redhat.com>
|
|
|
218e99 |
RH-Acked-by: Laszlo Ersek <lersek@redhat.com>
|
|
|
218e99 |
RH-Acked-by: Fam Zheng <famz@redhat.com>
|
|
|
218e99 |
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
|
218e99 |
|
|
|
218e99 |
BZ: 1004347
|
|
|
218e99 |
|
|
|
218e99 |
A new test on corrupted images with overlapping cluster allocations.
|
|
|
218e99 |
|
|
|
218e99 |
Signed-off-by: Max Reitz <mreitz@redhat.com>
|
|
|
218e99 |
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
|
|
|
218e99 |
(cherry picked from commit ca0eca91b65c34d6e5f5c77d5c18ed3de5b26139)
|
|
|
218e99 |
|
|
|
218e99 |
Signed-off-by: Max Reitz <mreitz@redhat.com>
|
|
|
218e99 |
|
|
|
218e99 |
Conflicts:
|
|
|
218e99 |
tests/qemu-iotests/group
|
|
|
218e99 |
|
|
|
218e99 |
Conflicts because upstream contains more tests in the group file.
|
|
|
218e99 |
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
|
|
|
218e99 |
---
|
|
|
218e99 |
tests/qemu-iotests/060 | 111 ++++++++++++++++++++++++++++++++++++++++++++
|
|
|
218e99 |
tests/qemu-iotests/060.out | 44 +++++++++++++++++
|
|
|
218e99 |
tests/qemu-iotests/group | 1 +
|
|
|
218e99 |
3 files changed, 156 insertions(+), 0 deletions(-)
|
|
|
218e99 |
create mode 100644 tests/qemu-iotests/060
|
|
|
218e99 |
create mode 100644 tests/qemu-iotests/060.out
|
|
|
218e99 |
|
|
|
218e99 |
diff --git a/tests/qemu-iotests/060 b/tests/qemu-iotests/060
|
|
|
218e99 |
new file mode 100644
|
|
|
218e99 |
index 0000000..65bb09f
|
|
|
218e99 |
--- /dev/null
|
|
|
218e99 |
+++ b/tests/qemu-iotests/060
|
|
|
218e99 |
@@ -0,0 +1,111 @@
|
|
|
218e99 |
+#!/bin/bash
|
|
|
218e99 |
+#
|
|
|
218e99 |
+# Test case for image corruption (overlapping data structures) in qcow2
|
|
|
218e99 |
+#
|
|
|
218e99 |
+# Copyright (C) 2013 Red Hat, Inc.
|
|
|
218e99 |
+#
|
|
|
218e99 |
+# This program is free software; you can redistribute it and/or modify
|
|
|
218e99 |
+# it under the terms of the GNU General Public License as published by
|
|
|
218e99 |
+# the Free Software Foundation; either version 2 of the License, or
|
|
|
218e99 |
+# (at your option) any later version.
|
|
|
218e99 |
+#
|
|
|
218e99 |
+# This program is distributed in the hope that it will be useful,
|
|
|
218e99 |
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
|
218e99 |
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
|
|
218e99 |
+# GNU General Public License for more details.
|
|
|
218e99 |
+#
|
|
|
218e99 |
+# You should have received a copy of the GNU General Public License
|
|
|
218e99 |
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
|
|
218e99 |
+#
|
|
|
218e99 |
+
|
|
|
218e99 |
+# creator
|
|
|
218e99 |
+owner=mreitz@redhat.com
|
|
|
218e99 |
+
|
|
|
218e99 |
+seq=`basename $0`
|
|
|
218e99 |
+echo "QA output created by $seq"
|
|
|
218e99 |
+
|
|
|
218e99 |
+here=`pwd`
|
|
|
218e99 |
+tmp=/tmp/$$
|
|
|
218e99 |
+status=1 # failure is the default!
|
|
|
218e99 |
+
|
|
|
218e99 |
+_cleanup()
|
|
|
218e99 |
+{
|
|
|
218e99 |
+ _cleanup_test_img
|
|
|
218e99 |
+}
|
|
|
218e99 |
+trap "_cleanup; exit \$status" 0 1 2 3 15
|
|
|
218e99 |
+
|
|
|
218e99 |
+# get standard environment, filters and checks
|
|
|
218e99 |
+. ./common.rc
|
|
|
218e99 |
+. ./common.filter
|
|
|
218e99 |
+
|
|
|
218e99 |
+# This tests qocw2-specific low-level functionality
|
|
|
218e99 |
+_supported_fmt qcow2
|
|
|
218e99 |
+_supported_proto generic
|
|
|
218e99 |
+_supported_os Linux
|
|
|
218e99 |
+
|
|
|
218e99 |
+rt_offset=65536 # 0x10000 (XXX: just an assumption)
|
|
|
218e99 |
+rb_offset=131072 # 0x20000 (XXX: just an assumption)
|
|
|
218e99 |
+l1_offset=196608 # 0x30000 (XXX: just an assumption)
|
|
|
218e99 |
+l2_offset=262144 # 0x40000 (XXX: just an assumption)
|
|
|
218e99 |
+
|
|
|
218e99 |
+IMGOPTS="compat=1.1"
|
|
|
218e99 |
+
|
|
|
218e99 |
+echo
|
|
|
218e99 |
+echo "=== Testing L2 reference into L1 ==="
|
|
|
218e99 |
+echo
|
|
|
218e99 |
+_make_test_img 64M
|
|
|
218e99 |
+# Link first L1 entry (first L2 table) onto itself
|
|
|
218e99 |
+# (Note the MSb in the L1 entry is set, ensuring the refcount is one - else any
|
|
|
218e99 |
+# later write will result in a COW operation, effectively ruining this attempt
|
|
|
218e99 |
+# on image corruption)
|
|
|
218e99 |
+poke_file "$TEST_IMG" "$l1_offset" "\x80\x00\x00\x00\x00\x03\x00\x00"
|
|
|
218e99 |
+_check_test_img
|
|
|
218e99 |
+
|
|
|
218e99 |
+# The corrupt bit should not be set anyway
|
|
|
218e99 |
+./qcow2.py "$TEST_IMG" dump-header | grep incompatible_features
|
|
|
218e99 |
+
|
|
|
218e99 |
+# Try to write something, thereby forcing the corrupt bit to be set
|
|
|
218e99 |
+$QEMU_IO -c "write -P 0x2a 0 512" "$TEST_IMG" | _filter_qemu_io
|
|
|
218e99 |
+
|
|
|
218e99 |
+# The corrupt bit must now be set
|
|
|
218e99 |
+./qcow2.py "$TEST_IMG" dump-header | grep incompatible_features
|
|
|
218e99 |
+
|
|
|
218e99 |
+# Try to open the image R/W (which should fail)
|
|
|
218e99 |
+$QEMU_IO -c "read 0 512" "$TEST_IMG" 2>&1 | _filter_qemu_io | sed -e "s/can't open device .*$/can't open device/"
|
|
|
218e99 |
+
|
|
|
218e99 |
+# Try to open it RO (which should succeed)
|
|
|
218e99 |
+$QEMU_IO -c "read 0 512" -r "$TEST_IMG" | _filter_qemu_io
|
|
|
218e99 |
+
|
|
|
218e99 |
+# We could now try to fix the image, but this would probably fail (how should an
|
|
|
218e99 |
+# L2 table linked onto the L1 table be fixed?)
|
|
|
218e99 |
+
|
|
|
218e99 |
+echo
|
|
|
218e99 |
+echo "=== Testing cluster data reference into refcount block ==="
|
|
|
218e99 |
+echo
|
|
|
218e99 |
+_make_test_img 64M
|
|
|
218e99 |
+# Allocate L2 table
|
|
|
218e99 |
+truncate -s "$(($l2_offset+65536))" "$TEST_IMG"
|
|
|
218e99 |
+poke_file "$TEST_IMG" "$l1_offset" "\x80\x00\x00\x00\x00\x04\x00\x00"
|
|
|
218e99 |
+# Mark cluster as used
|
|
|
218e99 |
+poke_file "$TEST_IMG" "$(($rb_offset+8))" "\x00\x01"
|
|
|
218e99 |
+# Redirect new data cluster onto refcount block
|
|
|
218e99 |
+poke_file "$TEST_IMG" "$l2_offset" "\x80\x00\x00\x00\x00\x02\x00\x00"
|
|
|
218e99 |
+_check_test_img
|
|
|
218e99 |
+./qcow2.py "$TEST_IMG" dump-header | grep incompatible_features
|
|
|
218e99 |
+$QEMU_IO -c "write -P 0x2a 0 512" "$TEST_IMG" | _filter_qemu_io
|
|
|
218e99 |
+./qcow2.py "$TEST_IMG" dump-header | grep incompatible_features
|
|
|
218e99 |
+
|
|
|
218e99 |
+# Try to fix it
|
|
|
218e99 |
+_check_test_img -r all
|
|
|
218e99 |
+
|
|
|
218e99 |
+# The corrupt bit should be cleared
|
|
|
218e99 |
+./qcow2.py "$TEST_IMG" dump-header | grep incompatible_features
|
|
|
218e99 |
+
|
|
|
218e99 |
+# Look if it's really really fixed
|
|
|
218e99 |
+$QEMU_IO -c "write -P 0x2a 0 512" "$TEST_IMG" | _filter_qemu_io
|
|
|
218e99 |
+./qcow2.py "$TEST_IMG" dump-header | grep incompatible_features
|
|
|
218e99 |
+
|
|
|
218e99 |
+# success, all done
|
|
|
218e99 |
+echo "*** done"
|
|
|
218e99 |
+rm -f $seq.full
|
|
|
218e99 |
+status=0
|
|
|
218e99 |
diff --git a/tests/qemu-iotests/060.out b/tests/qemu-iotests/060.out
|
|
|
218e99 |
new file mode 100644
|
|
|
218e99 |
index 0000000..ca4583a
|
|
|
218e99 |
--- /dev/null
|
|
|
218e99 |
+++ b/tests/qemu-iotests/060.out
|
|
|
218e99 |
@@ -0,0 +1,44 @@
|
|
|
218e99 |
+QA output created by 060
|
|
|
218e99 |
+
|
|
|
218e99 |
+=== Testing L2 reference into L1 ===
|
|
|
218e99 |
+
|
|
|
218e99 |
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=67108864
|
|
|
218e99 |
+ERROR cluster 3 refcount=1 reference=3
|
|
|
218e99 |
+
|
|
|
218e99 |
+1 errors were found on the image.
|
|
|
218e99 |
+Data may be corrupted, or further writes to the image may corrupt it.
|
|
|
218e99 |
+incompatible_features 0x0
|
|
|
218e99 |
+qcow2: Preventing invalid write on metadata (overlaps with active L1 table); image marked as corrupt.
|
|
|
218e99 |
+write failed: Input/output error
|
|
|
218e99 |
+incompatible_features 0x2
|
|
|
218e99 |
+qcow2: Image is corrupt; cannot be opened read/write.
|
|
|
218e99 |
+qemu-io: can't open device
|
|
|
218e99 |
+no file open, try 'help open'
|
|
|
218e99 |
+read 512/512 bytes at offset 0
|
|
|
218e99 |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
218e99 |
+
|
|
|
218e99 |
+=== Testing cluster data reference into refcount block ===
|
|
|
218e99 |
+
|
|
|
218e99 |
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=67108864
|
|
|
218e99 |
+ERROR refcount block 0 refcount=2
|
|
|
218e99 |
+ERROR cluster 2 refcount=1 reference=2
|
|
|
218e99 |
+
|
|
|
218e99 |
+2 errors were found on the image.
|
|
|
218e99 |
+Data may be corrupted, or further writes to the image may corrupt it.
|
|
|
218e99 |
+incompatible_features 0x0
|
|
|
218e99 |
+qcow2: Preventing invalid write on metadata (overlaps with refcount block); image marked as corrupt.
|
|
|
218e99 |
+write failed: Input/output error
|
|
|
218e99 |
+incompatible_features 0x2
|
|
|
218e99 |
+Repairing refcount block 0 refcount=2
|
|
|
218e99 |
+The following inconsistencies were found and repaired:
|
|
|
218e99 |
+
|
|
|
218e99 |
+ 0 leaked clusters
|
|
|
218e99 |
+ 1 corruptions
|
|
|
218e99 |
+
|
|
|
218e99 |
+Double checking the fixed image now...
|
|
|
218e99 |
+No errors were found on the image.
|
|
|
218e99 |
+incompatible_features 0x0
|
|
|
218e99 |
+wrote 512/512 bytes at offset 0
|
|
|
218e99 |
+512 bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
|
|
|
218e99 |
+incompatible_features 0x0
|
|
|
218e99 |
+*** done
|
|
|
218e99 |
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
|
|
|
218e99 |
index 1017a19..9c8826d 100644
|
|
|
218e99 |
--- a/tests/qemu-iotests/group
|
|
|
218e99 |
+++ b/tests/qemu-iotests/group
|
|
|
218e99 |
@@ -61,4 +61,5 @@
|
|
|
218e99 |
052 rw auto backing
|
|
|
218e99 |
053 rw auto
|
|
|
218e99 |
059 rw auto
|
|
|
218e99 |
+060 rw auto
|
|
|
218e99 |
068 rw auto
|
|
|
218e99 |
--
|
|
|
218e99 |
1.7.1
|
|
|
218e99 |
|